/*
Ingegneria delle TeleComunicazioni

III Appello AA 2004-2005

Esame del 12 Aprile 2005

SOLUZIONE DEL COMPITO


*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100
#define  Lstring 45


struct s_anagrafica
{
    int numero_tessera;
    char nome[Lstring];
    char cognome[Lstring];
    int anno;
    char sesso;
    
};

typedef struct s_anagrafica anagrafica;

struct s_discipline
{
    int numero_tessera;
    char nome_disciplina[Lstring];
    int punteggio;

};

typedef struct s_discipline discipline;


int Punteggi (discipline [], int);
float Situazione (discipline [], int);

int main (void)
{
    int record_trovati;
    int n_tessera;
    float media;
    
    discipline array_punteggio[MAX_ITEMS];
    
    printf("\nChe numero tessera ha l'atleta cercato? ");
    scanf("%d",&n_tessera);
    
    record_trovati=Punteggi(array_punteggio, n_tessera);
    printf("\nTrovate %d discipline\n",record_trovati);
    
    getch();
    
    media=Situazione (array_punteggio, record_trovati);
    
    printf("\nLa media dei punteggi delle discipline e' %.2f",media);
    
    getch();

    return 0;
}

int Punteggi (discipline array[], int n_tes)
{
    FILE *f;
    int i, appoggio, indice=0; 
    anagrafica atleta;
    
    int trovato=0; /*per uscire dal ciclo appena trovato l'atleta */

   
    if ((f=fopen("atleti.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (trovato==0))
        {
            fscanf(f, "%d %s %s %d %c", &atleta.numero_tessera, atleta.nome, atleta.cognome, &atleta.anno, &atleta.sesso);
            
            if (atleta.numero_tessera==n_tes)
            {
               printf("\nAtleta con matricola %d trovato.\n",n_tes);         
               trovato=1;
            }
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dell'anagrafica degli atleti"); 

    printf("\nNome: %s %s (%c)\nAnno di nascita: %d",atleta.nome, atleta.cognome, atleta.sesso, atleta.anno);

    /*ricerca delle discipline */
    
    if ((f=fopen("discipline.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (indice<=MAX_ITEMS))
        {
            fscanf(f, "%d %s %d", &appoggio, array[indice].nome_disciplina, &array[indice].punteggio);
            
            if (appoggio==n_tes) indice++;
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei punteggi"); 
    
    /*stampa del file */
    
    printf("\nDiscipline praticate dall'atleta\n\n");
    
    printf("\nNome\tPunteggio\n");
    for (i=0; i<indice; i++) printf("%s\t%d\n",array[i].nome_disciplina, array[i].punteggio);
    
    return(indice);
}



float Situazione (discipline array[], int dim_array)
{
    int somma_punteggi=0;
    float media;
    int i;
    
    int migliore_disciplina=1; //questo  l'indice, riferito all'array delle discipline praticate dall'atleta,
                               //che punta alla disciplina migliore
    
    printf("\nDiscipline in cui l'atleta si e' qualificato\n\n");
    
    printf("\nNome\tPunteggio\n");
    
    for (i=0; i<dim_array; i++) 
    {
         if (array[i].punteggio>=6) printf("%s\t%d\n",array[i].nome_disciplina, array[i].punteggio);
         somma_punteggi+=array[i].punteggio;
         
         if (array[i].punteggio>array[migliore_disciplina].punteggio) migliore_disciplina=i;
    }    
    media=(float)  somma_punteggi /   dim_array;
    
    printf("\nL'atleta ha conseguito il miglior punteggio in %s (punti: %d)\n",
                       array[migliore_disciplina].nome_disciplina, array[migliore_disciplina].punteggio);    
            
    return media;
}    
 


