/*
Ingegneria delle TeleComunicazioni e Automatica

II Appello AA 2006-2007

Esame del 12 Gennaio 2007

SOLUZIONE DEL COMPITO Videoteca

*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100


struct s_dvd
{
    int matricola_cliente;
    char titolo[30];
    char d_iniz_prestito[11];
    char d_fine_prestito[11];
    
};

typedef struct s_dvd dvd;

int dvd_cliente (dvd [], char []);
int disponibileDvd (char []);

int main (void)
{
    int disponibile;
    char CF[17];
    int record_trovati;
    char titolo[30];
    
    
    dvd elenco_dvd[MAX_ITEMS];
    
    printf("\nChe Codice Fiscale cerchi? ");
    scanf("%s",CF);
    
    record_trovati=dvd_cliente(elenco_dvd, CF);
    printf("\nTrovati %d dvd",record_trovati);
    
    getch();
    
    printf("\n\nChe DVD vuoi cercare? ");
    scanf("%s",titolo);
    disponibile=disponibileDvd (titolo);
    
    printf("\nIl DVD %s e\' ",titolo);
    if (disponibile==1) printf("disponibile\n");
    else printf("non disponibile\n");
    
    getch();

    return 0;
}

int dvd_cliente (dvd array[], char codfis[17])
{
    FILE *f;
    int i, indice=0; 

    int matricola;
    char cf[17];
    
    int trovato=0; /*per finire il ciclo di lettura appena trovato il cliente */
    
    if ((f=fopen("c:\\esame\\anagrafica.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (trovato==0))
        {
            fscanf(f, "%d %s %*s %*s", &matricola, cf);
            
            if (strcmp(cf, codfis)==0)
            {
               printf("\nCliente con codice fiscale %s trovato.\nMatricola: %d",cf,matricola);         
               trovato=1;
            }
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei clienti"); 

    /*ricerca dei dvd */
    
    if ((f=fopen("c:\\esame\\dvd.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (indice<=MAX_ITEMS))
        {
            fscanf(f, "%d %s %s %s", &array[indice].matricola_cliente, array[indice].titolo, array[indice].d_iniz_prestito, array[indice].d_fine_prestito);
            
            if (array[indice].matricola_cliente==matricola) indice++;
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei dvd"); 
    
    /*stampa del file */
    
    printf("\nDvd del cliente %d\n",matricola);
    for (i=0; i<indice; i++) printf("%s\t%s\t%s\n",array[i].titolo, array[i].d_iniz_prestito, array[i].d_fine_prestito);
    
    return(indice);
}

int disponibileDvd (char titolo[30])
{
    int disp=1;
    FILE *f;
    dvd DVD;
    
    char tit[30];
    
   if ((f=fopen("c:\\esame\\dvd.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%d %s %s %s", &DVD.matricola_cliente, DVD.titolo, DVD.d_iniz_prestito, DVD.d_fine_prestito);
            
             if (strcmp(titolo, DVD.titolo)==0) 
             {
               printf("%d\t%s\t%s\t%s\n",DVD.matricola_cliente,DVD.titolo, DVD.d_iniz_prestito, DVD.d_fine_prestito);
               if (strcmp(DVD.d_fine_prestito,"N/A")==0) disp=0;
             }
                                
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei dvd"); 
            
    return (disp);
}    
