/*
Ingegneria delle TeleComunicazioni e Automatica
Esame del 27 Settembre 2006
*/

/*
Nome:
Cognome:
Matricola:
Posizione:
*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100
#define  L_PRESTAZIONE    15
#define  L_CLIENTE    15
#define  L_OPERATORE    6

struct s_prestazione
{
    int codice;
    char prestazione[L_PRESTAZIONE];
    int ore_lavorazione;
    char cliente[L_CLIENTE];
    char operatore[L_OPERATORE];
    int costo;
};

typedef struct s_prestazione Prestazioni;

int CaricaDati (struct s_prestazione []);
void PrestazioniEffettuatePerTipo (struct s_prestazione [], char []);
void RiassuntoPrestazioni (struct s_prestazione []);


int numero_prestazioni=0;

int main (void)
{
    Prestazioni ElencoPrestazioni[MAX_ITEMS];
    char tipo, scelta;
      
    numero_prestazioni=CaricaDati (ElencoPrestazioni);
    
    printf("\nCaricati %d elementi",numero_prestazioni);

    printf("\nCerca prestazioni per tipologia");
    
    do
    {
       
                
        do
        {
               printf("\nTipologia {Taglio, tIntura, messa in Piega}:");
               tipo=getch();
        }
        while (!((tipo=='T') || (tipo=='I') || (tipo=='P'))); 
        
        switch (tipo)
        {
            case 'T': { PrestazioniEffettuatePerTipo (ElencoPrestazioni, "taglio"); break; }
            case 'I': { PrestazioniEffettuatePerTipo (ElencoPrestazioni, "tintura"); break; }
            case 'P': { PrestazioniEffettuatePerTipo (ElencoPrestazioni, "messa_in_piega"); break; }
        }    
        

                
        printf("\n\nAncora? (S/N)");
        scelta=getch();
        
    }
    while (!((scelta=='N') || (scelta=='n')));
   
    printf("\nPremi un tasto per terminare");
    getch();

    RiassuntoPrestazioni (ElencoPrestazioni);

    printf("\nPremi un tasto per terminare");
    getch();

    return 0;
}

void PrestazioniEffettuatePerTipo (struct s_prestazione ElencoPrestazioni[], char prestazione[])
{
    int i;
        
    printf("\n\n\nRicerca delle prestazioni di tipo %s\n======================================",prestazione);

    for (i=0; i<numero_prestazioni; i++)
    {
        if (strcmp(ElencoPrestazioni[i].prestazione,prestazione)==0)
         {
             printf("\n%d\t%s\t\t%s\t%d\t%d",
                          ElencoPrestazioni[i].codice,
                          ElencoPrestazioni[i].cliente,
                          ElencoPrestazioni[i].operatore,
                          ElencoPrestazioni[i].ore_lavorazione,
                          ElencoPrestazioni[i].costo
             );
        }
    }
    return ;
}
 
void RiassuntoPrestazioni (struct s_prestazione ElencoPrestazioni[])
{    
   int i;    
   int taglio_tot=0, tintura_tot=0, messa_in_piega_tot=0;
      
    for (i=0; i<numero_prestazioni; i++)
    {     
        /*Calcoli per il riassunto*/
         if (strcmp(ElencoPrestazioni[i].prestazione,"taglio")==0) taglio_tot++;
         if (strcmp(ElencoPrestazioni[i].prestazione,"tintura")==0) tintura_tot++;  
         if (strcmp(ElencoPrestazioni[i].prestazione,"messa_in_piega")==0) messa_in_piega_tot++;
    }
  
    printf("\n\nRiassunto:\nTAGLIO:\t%d",taglio_tot);
    printf("\nTINTURA:\t%d",tintura_tot);
    printf("\nMESSA IN PIEGA:\t%d",messa_in_piega_tot);
    
   if ((taglio_tot>tintura_tot) && (taglio_tot>messa_in_piega_tot)) printf("\nTAGLIO: e' la prestazione piu' richiesta ");
   if ((tintura_tot>taglio_tot) && (tintura_tot>messa_in_piega_tot)) printf("\nTINTURA: e' la prestazione piu' richiesta ");
   if ((messa_in_piega_tot>taglio_tot) && (messa_in_piega_tot>tintura_tot)) printf("\nMESSA IN PIEGA: e' la prestazione piu' richiesta ");

   return ;
}


int CaricaDati (struct s_prestazione ElencoPrestazioni[])
{
    FILE *f;
    struct s_prestazione appo_prestazioni;
    int prestazioni_trovate=0;
               
    if ((f=fopen("Prestazioni.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%d %s %d %s %s %d", 
             &appo_prestazioni.codice,
             appo_prestazioni.prestazione,  
             &appo_prestazioni.ore_lavorazione, 
             appo_prestazioni.cliente, 
             appo_prestazioni.operatore, 
             &appo_prestazioni.costo
            );

            ElencoPrestazioni[prestazioni_trovate]=appo_prestazioni;
            
            prestazioni_trovate++;
            
         }
         
         if (prestazioni_trovate==0) printf("\nNessuna prestazione trovata");
        
        fclose(f); 
    }
    else printf("\nErrore nel file"); 
    
    return prestazioni_trovate;
}

