/*
Ingegneria delle TeleComunicazioni

III Appello AA 2006-2007

Esame del 30 Marzo 2007

SOLUZIONE DEL COMPITO


*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100
#define  Lstring 45
#define  Ldata 9


struct s_stanze
{
    int numero_stanza;
    int piano;
    char tipologia;
    int costo;
    int numero_cliente;
    char data_inizio[Ldata];
    char data_fine[Ldata];
    
};

typedef struct s_stanze stanze;

struct s_cliente
{
    int numero_cliente;
    char nome[Lstring];
    char cognome[Lstring];

};

typedef struct s_cliente cliente;

int Carica (stanze [], char, int);
void Situazione (char [], char []);

stanze stanze_occupate[MAX_ITEMS];
int size_stanze_occupate;

int main (void)
{
    int n_tessera;
    char tipologia;
    int costo_max;
    
    char name[Lstring];
    char surname[Lstring];
        
    stanze stanze_disponibili[MAX_ITEMS];
       
    printf("\nTipologia desiderata? ");
    scanf("%c",&tipologia);
    
    printf("\nCosto massimo cercato? ");
    scanf("%d",&costo_max);

    
    size_stanze_occupate=Carica(stanze_disponibili, tipologia, costo_max);
    printf("\nTrovate %d stanze occupate\n",size_stanze_occupate);
    
    getch();

    printf("\nNome cliente? ");
    scanf("%s",name);

    printf("\nCognome cliente? ");
    scanf("%s",surname);

    Situazione (name, surname);
    
    getch();

    return 0;
}

int Carica (stanze array[], char t, int costo)
{
    FILE *f;
    int indice_stanzelibere=0, indice_stanzeoccupate=0, i;
    stanze appoggio;

    //per la stanza pi economica
    int min_price;
    int num_stanza_economica;
       
    if ((f=fopen("stanze.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%d %d %c %d %d %s %s", &appoggio.numero_stanza, &appoggio.piano, &appoggio.tipologia, &appoggio.costo, &appoggio.numero_cliente, appoggio.data_inizio, appoggio.data_fine);
            
            if (appoggio.numero_cliente!=0) 
            {
               stanze_occupate[indice_stanzeoccupate]=appoggio;
               indice_stanzeoccupate++;
            }
            
            else
            
            if ((appoggio.costo<=costo) && (appoggio.tipologia==t)) 
            {
               array[indice_stanzelibere]=appoggio;
               indice_stanzelibere++;
            }
         }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dell'anagrafica degli atleti"); 

    printf("Stanze disponibili secondo i criteri impostati:\n");
    
    //imposto il prezzo minimo
    if (indice_stanzelibere==0) printf("Nessuna stanza libera trovata\n");
    else
    {
       min_price=array[1].costo;
       num_stanza_economica=array[1].numero_stanza;
       for (i=0; i<indice_stanzelibere; i++)
       {
              printf("%d\t%d\t%c\t%d\t%d\t%s\t%s\n",array[i].numero_stanza, array[i].piano, array[i].tipologia, array[i].costo, array[i].numero_cliente, array[i].data_inizio, array[i].data_fine);
              if (array[i].costo<min_price) 
              {
                min_price=array[i].costo;
                num_stanza_economica=array[i].numero_stanza;
              }    
       }    
       printf("Stanza piu' economica: %d a %dE\n",num_stanza_economica, min_price);
    }    
    
    return(indice_stanzeoccupate);
}



void Situazione (char n[Lstring], char c[Lstring])
{
    FILE *f;
    cliente appoggio;
    int trovato=0;
    int i=0;
    
    if ((f=fopen("clienti.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        //printf("Cerco %s %s\n",n,c);
        
        while ((!feof(f)) && (trovato==0))
        {
            fscanf(f, "%d %s %s", &appoggio.numero_cliente, appoggio.nome, appoggio.cognome);
            
            //printf ("Esamino %s %s\n", appoggio.nome, appoggio.cognome);
            
            if ((strcmp(appoggio.nome, n)==0) && (strcmp(appoggio.cognome, c)==0))
            {
               printf("\nIl cliente %s %s ha codice %d\n\n",n,c,appoggio.numero_cliente); 
               trovato=1;
            }
            
         }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dell'anagrafica degli atleti");   
    
    while ((i<size_stanze_occupate) && (stanze_occupate[i].numero_cliente!=appoggio.numero_cliente)) i++;      
    
    if (stanze_occupate[i].numero_cliente==appoggio.numero_cliente) printf("Stanza: %d\nPiano: %d\nTipologia: %c\nCosto: %d\nOccupata dal %s al %s\n",stanze_occupate[i].numero_stanza, stanze_occupate[i].piano, stanze_occupate[i].tipologia, stanze_occupate[i].costo, stanze_occupate[i].data_inizio, stanze_occupate[i].data_fine);               
    else printf("Il cliente non occupa nessuna stanza\n");
                   
    return;
}    
 

