#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100


struct s_traslochi
{
    int codice_trasloco;
    int codice_cliente;
    char data[11];
    char citta_origine[25];
    char citta_destinazione[25];
    int costo;
    
};

typedef struct s_traslochi traslochi;

int TrovaTraslochi (traslochi [], char *);
float FuoriTerritorio (traslochi []);

int main (void)
{
    int numero_traslochi;
    char citta_da_cercare[25];

    traslochi TRASLOCHI[MAX_ITEMS];
    
    printf("\nChe citta\' vuoi cercare? ");
    scanf("%s",citta_da_cercare);
    
    numero_traslochi=TrovaTraslochi(TRASLOCHI, citta_da_cercare);
    printf("\nTrovati %d traslochi",numero_traslochi);
    
    getch();
    
    printf("\nAbbiamo il %5.2f%% di traslochi fuori sede",FuoriTerritorio (TRASLOCHI));
    
    getch();

    return 0;
}

int TrovaTraslochi (traslochi arraytraslochi[], char *citta)
{
    FILE *f;
    int indice=0;
    
    if ((f=fopen("EFFETTUATI.DAT", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (indice<=MAX_ITEMS))
        {
            fscanf(f, "%d %d %s %s %s %d", &arraytraslochi[indice].codice_trasloco, &arraytraslochi[indice].codice_cliente, 
            arraytraslochi[indice].data, arraytraslochi[indice].citta_origine, arraytraslochi[indice].citta_destinazione,
            &arraytraslochi[indice].costo);
            
            if (strcmp(arraytraslochi[indice].citta_origine,citta)==0)
            {
               printf("\n%d %d %s %s %s %d",arraytraslochi[indice].codice_trasloco, arraytraslochi[indice].codice_cliente, 
               arraytraslochi[indice].data, arraytraslochi[indice].citta_origine, arraytraslochi[indice].citta_destinazione,
               arraytraslochi[indice].costo);
               
               indice++;
            }
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file"); 
    
    return(indice);
}

float FuoriTerritorio (traslochi arraytraslochi[])
{
    FILE *f;
    int num_traslochi_fuori=0, tot_traslochi=0;
    char citta_origine[25], citta_destinazione[25];
    int appo;
    char appostringa[25];
       
    if ((f=fopen("EFFETTUATI.DAT", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%*d %*d %*s %s %s %*d", citta_origine, citta_destinazione);
                    
            if (strcmp(citta_origine, citta_destinazione)!=0) num_traslochi_fuori++;
            tot_traslochi++;
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file"); 
    
    return ((num_traslochi_fuori * 100) / tot_traslochi);
}

