/*
Ingegneria delle TeleComunicazioni

I Appello AA 2006-2007

Esame del 15 Dicembre 2006

SOLUZIONE DEL COMPITO


*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100
#define  Lstring 45


struct s_anagrafica
{
    int numero_tessera;
    char nome[Lstring];
    char cognome[Lstring];
    int anno;
    char sesso;
    
};

typedef struct s_anagrafica anagrafica;

struct s_discipline
{
    int numero_tessera;
    char gruppo_muscolare[Lstring];
    int ore;

};

typedef struct s_discipline discipline;


int Scheda (discipline [], int);
float Situazione (discipline [], int, int);

int main (void)
{
    int record_trovati;
    int n_tessera;
    float media;
    int ore;
    
    discipline array_ore[MAX_ITEMS];
    
    printf("\nChe numero tessera ha il socio cercato? ");
    scanf("%d",&n_tessera);
    
    record_trovati=Scheda(array_ore, n_tessera);
    printf("\nTrovati %d gruppi muscolari\n",record_trovati);
    
    getch();
    
    printf("\nOre minime di allenamento? ");
    scanf("%d",&ore);
    
    media=Situazione (array_ore, record_trovati, ore);
    
    printf("\nLa media delle ore di allenamento e' %.2f",media);
    
    getch();

    return 0;
}

int Scheda (discipline array[], int n_tes)
{
    FILE *f;
    int i, appoggio, indice=0; 
    anagrafica atleta;
    
    int trovato=0; /*per uscire dal ciclo appena trovato l'atleta */

   
    if ((f=fopen("soci.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (trovato==0))
        {
            fscanf(f, "%d %s %s %d %c", &atleta.numero_tessera, atleta.nome, atleta.cognome, &atleta.anno, &atleta.sesso);
            
            if (atleta.numero_tessera==n_tes)
            {
               printf("\nSocio con matricola %d trovato.\n",n_tes);         
               trovato=1;
            }
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dell'anagrafica dei soci"); 

    printf("\nNome: %s %s (%c)\nAnno di nascita: %d",atleta.nome, atleta.cognome, atleta.sesso, atleta.anno);

    /*ricerca delle discipline */
    
    if ((f=fopen("allenamento.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (indice<=MAX_ITEMS))
        {
            fscanf(f, "%d %s %d", &appoggio, array[indice].gruppo_muscolare, &array[indice].ore);
            
            if (appoggio==n_tes) indice++;
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file delle ore"); 
    
    /*stampa del file */
    
    printf("\nGruppi muscolari in cui il socio si allena\n\n");
    
    printf("\nNome\tOre\n");
    for (i=0; i<indice; i++) printf("%s\t%d\n",array[i].gruppo_muscolare, array[i].ore);
    
    return(indice);
}



float Situazione (discipline array[], int dim_array, int h)
{
    int somma_ore=0;
    float media;
    int i;
    
    int migliore_gm=1;          //questo  l'indice, riferito all'array delle ore praticate dal socio,
                               //che punta al gruppo muscolare pi allenato
    
    printf("\nGruppi muscolari in cui il socio si allena per pi di %d ore\n\n",h);
    
    printf("\nNome\tOre\n");
    
    for (i=0; i<dim_array; i++) 
    {
         if (array[i].ore>=h) printf("%s\t%d\n",array[i].gruppo_muscolare, array[i].ore);
         somma_ore+=array[i].ore;
         
         if (array[i].ore>array[migliore_gm].ore) migliore_gm=i;
    }    
    media=(float)  somma_ore /   dim_array;
    
    printf("\nIl socio si allena maggiormente in %s (ore: %d)\n",
                       array[migliore_gm].gruppo_muscolare, array[migliore_gm].ore);    
            
    return media;
}    
 


