/*
Ingegneria delle TeleComunicazioni
Esame del 19 Dicembre 2005
*/

/*
Nome:
Cognome:
Matricola:
Posizione:
*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100
#define  L_TIPOLOGIA    15
#define  L_LIVELLO    15
#define  L_ORARIO    6

struct s_corso
{
    int codice;
    char tipologia[L_TIPOLOGIA];
    char livello[L_LIVELLO];
    int max_partecipanti;
    int num_partecipanti;
    char orario[L_ORARIO];
};

typedef struct s_corso Corso;

int CaricaDati (struct s_corso []);
void CorsiDisponibiliPerLivello (struct s_corso [], char []);


int numero_corsi=0;

int main (void)
{
    Corso ElencoCorsi[MAX_ITEMS];
    char livello, scelta;
      
    numero_corsi=CaricaDati (ElencoCorsi);
    
    printf("\nCaricati %d elementi",numero_corsi);

    printf("\nCerca corsi per livello");
    
    do
    {
       
                
        do
        {
               printf("\nTipologia {Principiante, Intermedio, Avanzato}:");
               livello=getch();
        }
        while (!((livello=='P') || (livello=='I') || (livello=='A'))); 
        
        switch (livello)
        {
            case 'P': { CorsiDisponibiliPerLivello (ElencoCorsi, "principianti"); break; }
            case 'I': { CorsiDisponibiliPerLivello (ElencoCorsi, "intermedio"); break; }
            case 'A': { CorsiDisponibiliPerLivello (ElencoCorsi, "avanzato"); break; }
        }    
        

                
        printf("\n\nAncora? (S/N)");
        scelta=getch();
        
    }
    while (!((scelta=='N') || (scelta=='n')));
   
    printf("\nPremi un tasto per terminare");
    getch();

    return 0;
}

void CorsiDisponibiliPerLivello (struct s_corso ElencoCorsi[], char livello[])
{
    int i;
    
    int princ_tot=0, princ_avail=0, inter_tot=0, inter_avail=0, avanza_tot=0, avanza_avail=0;
    
    printf("\n\n\nRicerca dei corsi di tipo %s\n======================================",livello);

    for (i=0; i<numero_corsi; i++)
    {
        if ((strcmp(ElencoCorsi[i].livello,livello)==0) && ((ElencoCorsi[i].max_partecipanti-ElencoCorsi[i].num_partecipanti)>0))
         {
             printf("\n%d\t%s\t\t%s\t%d posti",ElencoCorsi[i].codice,ElencoCorsi[i].orario,ElencoCorsi[i].tipologia, ElencoCorsi[i].max_partecipanti-ElencoCorsi[i].num_partecipanti);
         }
        
        /*Calcoli per il riassunto*/
         if (strcmp(ElencoCorsi[i].livello,"intermedio")==0)
         {
             inter_tot++;
             if ((ElencoCorsi[i].max_partecipanti-ElencoCorsi[i].num_partecipanti)>0) inter_avail++;
         }
          if (strcmp(ElencoCorsi[i].livello,"principianti")==0)
         {
            princ_tot++;  
            if ((ElencoCorsi[i].max_partecipanti-ElencoCorsi[i].num_partecipanti)>0) princ_avail++;
         } 
          if (strcmp(ElencoCorsi[i].livello,"avanzato")==0)
         {
            avanza_tot++;
            if ((ElencoCorsi[i].max_partecipanti-ElencoCorsi[i].num_partecipanti)>0) avanza_avail++;
         }     
    }

    printf("\n\nRiassunto:\nPRINCIPIANTI:\tcorsi %d di cui %d con ancora posti disponibili",princ_tot,princ_avail);
    printf("\nINTERMEDIO:\tcorsi %d di cui %d con ancora posti disponibili",inter_tot,inter_avail);
    printf("\nAVANZATO:\tcorsi %d di cui %d con ancora posti disponibili",avanza_tot,avanza_avail);
    
    return;
}


int CaricaDati (struct s_corso ElencoCorsi[])
{
    FILE *f;
    struct s_corso appo_corso;
    int corsi_trovati=0;
               
    if ((f=fopen("Corsi.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%d %s %s %d %d %s", 
             &appo_corso.codice,
             appo_corso.livello,  
             appo_corso.tipologia, 
             &appo_corso.max_partecipanti, 
             &appo_corso.num_partecipanti, 
             appo_corso.orario
            );

            ElencoCorsi[corsi_trovati]=appo_corso;
            
            corsi_trovati++;
            
         }
         
         if (corsi_trovati==0) printf("\nNessun corso trovatao");
        
        fclose(f); 
    }
    else printf("\nErrore nel file"); 
    
    return corsi_trovati;
}

