/*
Ingegneria delle TeleComunicazioni e Automatica

II Appello AA 2005-2006

Esame del 20 Gennaio 2006

SOLUZIONE DEL COMPITO BIBLIOTECA

*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100


struct s_libri
{
    int matricola_cliente;
    char titolo[30];
    char d_iniz_prestito[11];
    char d_fine_prestito[11];
    
};

typedef struct s_libri libri;

int libri_cliente (libri [], char []);
int disponibileLibro (char []);

int main (void)
{
    int disponibile;
    char CF[17];
    int record_trovati;
    char titolo[30];
    
    
    libri elenco_libri[MAX_ITEMS];
    
    printf("\nChe Codice Fiscale cerchi? ");
    scanf("%s",CF);
    
    record_trovati=libri_cliente(elenco_libri, CF);
    printf("\nTrovati %d libri",record_trovati);
    
    getch();
    
    printf("\n\nChe libro vuoi caricare? ");
    scanf("%s",titolo);
    disponibile=disponibileLibro (titolo);
    
    printf("\nIl libro %s e\' ",titolo);
    if (disponibile==1) printf("disponibile\n");
    else printf("non disponibile\n");
    
    getch();

    return 0;
}

int libri_cliente (libri array[], char codfis[17])
{
    FILE *f;
    int i, indice=0; 

    int matricola;
    char cf[17];
    
    int trovato=0; /*per finire il ciclo di lettura appena trovato il cliente */
    
    if ((f=fopen("c:\\esame\\anagrafica.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (trovato==0))
        {
            fscanf(f, "%d %s %*s %*s", &matricola, cf);
            
            if (strcmp(cf, codfis)==0)
            {
               printf("\nCliente con codice fiscale %s trovato.\nMatricola: %d",cf,matricola);         
               trovato=1;
            }
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei clienti"); 

    /*ricerca dei libri */
    
    if ((f=fopen("c:\\esame\\libri.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (indice<=MAX_ITEMS))
        {
            fscanf(f, "%d %s %s %s", &array[indice].matricola_cliente, array[indice].titolo, array[indice].d_iniz_prestito, array[indice].d_fine_prestito);
            
            if (array[indice].matricola_cliente==matricola) indice++;
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei libri"); 
    
    /*stampa del file */
    
    printf("\nLibri del cliente %d\n",matricola);
    for (i=0; i<indice; i++) printf("%s\t%s\t%s\n",array[i].titolo, array[i].d_iniz_prestito, array[i].d_fine_prestito);
    
    return(indice);
}

int disponibileLibro (char titolo[30])
{
    int disp=1;
    FILE *f;
    libri libro;
    
    char tit[30];
    
   if ((f=fopen("c:\\esame\\libri.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%d %s %s %s", &libro.matricola_cliente, libro.titolo, libro.d_iniz_prestito, libro.d_fine_prestito);
            
             if (strcmp(titolo, libro.titolo)==0) 
             {
               printf("%d\t%s\t%s\t%s\n",libro.matricola_cliente,libro.titolo, libro.d_iniz_prestito, libro.d_fine_prestito);
               if (strcmp(libro.d_fine_prestito,"N/A")==0) disp=0;
             }
                                
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file dei libri"); 
            
    return (disp);
}    
