/*
Ingegneria delle TeleComunicazioni e Automatica

III Appello AA 2005-2006

Esame del 21 Aprile 2006

SOLUZIONE DEL COMPITO PALESTRA

*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100


struct s_istruttore
{
    int matricola_istruttore;
    char qualifica[30];
    char nome[15];
    char cognome[15];
};

struct s_lezione
{
    int matricola_istruttore;
    char tipo_lezione[30];
    char ora_inizio[11];
    char ora_fine[11];
    char dayOfWeek[10];
};

typedef struct s_istruttore istruttore;
typedef struct s_lezione lezione;

int trovaLezione_perTipo (char []);
int trovaLezione_perGiorno (char []);

int lezioniIstruttore (char [], char []);

void stampaLezioni (int);

lezione lezioni[MAX_ITEMS];

int main (void)
{
    int numero_lezioni;
    char nome[15];
    char cognome[15];
    char tipo[30];
    char dayWeek [10];
  
        
    printf("\nTipo di lezione cercata? ");
    scanf("%s",tipo);
    numero_lezioni=trovaLezione_perTipo (tipo);
    printf("\nTrovate %d lezioni",numero_lezioni);
    getch();

    printf("\nGiorno della settimana desiderato? ");
    scanf("%s",dayWeek);
    numero_lezioni=trovaLezione_perGiorno (dayWeek);
    printf("\nTrovate %d lezioni",numero_lezioni);
    getch();

    printf("\nNome? ");
    scanf("%s",nome);
    
    printf("\nCognome? ");
    scanf("%s",cognome);
    
    numero_lezioni=lezioniIstruttore(nome, cognome);
    printf("\nTrovate %d lezioni",numero_lezioni);
    stampaLezioni (numero_lezioni);
    getch();

    return 0;
}

int lezioniIstruttore (char name[15], char surname[15])
{
    FILE *f;
    int indice=0; 
   
    istruttore i;
    
    int trovato=0; /*per finire il ciclo di lettura appena trovato l'istruttore */
    
    if ((f=fopen("c:\\esame\\Istruttori.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (trovato==0))
        {
            fscanf(f, "%d %*s %s %s", &i.matricola_istruttore, i.nome, i.cognome);
            
            if ( (strcmp(name, i.nome)==0) && (strcmp(surname, i.cognome)==0) )
            {
               printf("\nIstruttore %s %s con matricola %d trovato.\n",i.nome, i.cognome, i.matricola_istruttore);         
               trovato=1;
            }
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file degli istruttori"); 

    /*ricerca delle lezioni */
    
    if ((f=fopen("c:\\esame\\Orari.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f) && (indice<=MAX_ITEMS))
        {
            fscanf(f, "%d %s %s %s %s", &lezioni[indice].matricola_istruttore, lezioni[indice].tipo_lezione, 
                                    lezioni[indice].ora_inizio, lezioni[indice].ora_fine, lezioni[indice].dayOfWeek);
            
            if (lezioni[indice].matricola_istruttore==i.matricola_istruttore) indice++;
                        
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file degli orari"); 
    
    /*stampa del file */
       
    return (indice);
}

void stampaLezioni (int numero_lezioni)
{
    int indice;
    
    printf("\nLezioni dell'istruttore %d\n",lezioni[0].matricola_istruttore);
    for (indice=0; indice<numero_lezioni; indice++)
        printf("%s\t%s\t%s\t%s\n",lezioni[indice].tipo_lezione, 
                                    lezioni[indice].ora_inizio, lezioni[indice].ora_fine, lezioni[indice].dayOfWeek);
   
}
int trovaLezione_perTipo (char type[30])
{
    FILE *f;
    lezione l;
    int disp=0;
    
   if ((f=fopen("c:\\esame\\Orari.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%*d %s %s %s %s", l.tipo_lezione, l.ora_inizio, l.ora_fine, l.dayOfWeek);
            
             if (strcmp(type, l.tipo_lezione)==0) 
             {
               disp++;
               printf("%s\t%s\t%s\n",l.ora_inizio, l.ora_fine, l.dayOfWeek);
             }
                       
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file degli orari"); 
            
    return (disp);
}  

int trovaLezione_perGiorno (char dayW[10])
{
    FILE *f;
    lezione l;
    int disp=0;
    
   if ((f=fopen("c:\\esame\\Orari.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%*d %s %s %s %s", l.tipo_lezione, l.ora_inizio, l.ora_fine, l.dayOfWeek);
            
             if (strcmp(dayW, l.dayOfWeek)==0) 
             {
               disp++;
               printf("%s\t%s\t%s\n",l.tipo_lezione, l.ora_inizio, l.ora_fine);
             }
                       
        }
        
        fclose(f); 
    }
    else printf("\nErrore nel file degli orari"); 
            
    return (disp);
} 

