/*
Ingegneria delle TeleComunicazioni
Esame del 16 Luglio 2004
*/

/*
Nome:
Cognome:
Matricola:
Posizione:
Progetto: 
   [ ] presentato
   [ ] da presentare
   [ ] non interessato
*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 1000
#define  L_NOMI    30
#define  L_INDIRIZZO    40

struct Persona
{
    char nome[L_NOMI];
    char cognome[L_NOMI];
    char indirizzo[L_INDIRIZZO];
};

struct s_lettera
{
    Persona mittente;
    Persona destinatario;
    char tipo_lettera;
    char data_spedizione[11];
};

typedef struct s_lettera Lettera;

int InserisciLettera (struct s_lettera);
int CaricaFile (char);

Lettera UfficioPostale[MAX_ITEMS];
int numero_lettere=0;

int main (void)
{
    char scelta;
    Lettera l1;
    
    numero_lettere=CaricaFile ('a');
    
    do
    {
        printf("\nNome mittente:");
        scanf("%s",l1.mittente.nome);
        
        printf("\nCognome mittente:");
        scanf("%s",l1.mittente.cognome);
        
        printf("Via mittente:");
        scanf("%s",l1.mittente.indirizzo);
        
        printf("\nNome destinatario:");
        scanf("%s",l1.destinatario.nome);
        
        printf("\nCognome destinatario:");
        scanf("%s",l1.destinatario.cognome);
        
        printf("Via destinatario:");
        scanf("%s",l1.destinatario.indirizzo);
        
        do
        {
               printf("\nTipo lettera {r, a, n}:");
               l1.tipo_lettera=getch();
        }
        while (!((l1.tipo_lettera=='r') || (l1.tipo_lettera=='a') || (l1.tipo_lettera=='n'))); 
        
        printf("\nData spedizione (gg/mm/aaaa):");
        scanf("%s",l1.data_spedizione);
        
        printf("\nDATI INSERITI");
        printf("\n==============");
        printf("\n%s %s (%s)\n%s %s (%s)\n%c %s",
          l1.mittente.nome, l1.mittente.cognome, l1.mittente.indirizzo, 
          l1.destinatario.nome, l1.destinatario.cognome, l1.destinatario.indirizzo, 
          l1.tipo_lettera, l1.data_spedizione);
        
        numero_lettere=InserisciLettera(l1);
        printf("\nAttualmente in Ufficio Postale abbiamo %d lettere",numero_lettere);
        
        printf("\n\nAncora? (S/N)");
        scelta=getch();
        
    }
    while (!((scelta=='N') || (scelta=='n')));
    
    printf("\nPremi un tasto per terminare");
    getch();

    return 0;
}

int InserisciLettera (struct s_lettera let)
{
    int i;

    if (numero_lettere>MAX_ITEMS) 
        printf("\nUfficio Postale pieno\nImpossibile aggiungere altre lettere");
    else
    {
        UfficioPostale[numero_lettere]=let;
        numero_lettere++;
        
        printf("\n\nSTAMPA DI UFFICIO POSTALE\n====================================");
        
        for (i=0; i<numero_lettere; i++)
        {
           printf("\nMittente: %s %s (%s)\nDestinatario: %s %s (%s)\n%c %s\n---------------------------------",
             UfficioPostale[i].mittente.nome, 
             UfficioPostale[i].mittente.cognome, 
             UfficioPostale[i].mittente.indirizzo, 
             UfficioPostale[i].destinatario.nome, 
             UfficioPostale[i].destinatario.cognome, 
             UfficioPostale[i].destinatario.indirizzo, 
             UfficioPostale[i].tipo_lettera, 
             UfficioPostale[i].data_spedizione);     
        }
    }
    
    return(numero_lettere);
}


int CaricaFile (char tipo)
{
    FILE *f;
    struct s_lettera appo_let;
    int lettere_trovate=0;
               
    if ((f=fopen("lettere.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%s %s %s %s %s %s %c %s", 
             appo_let.mittente.nome, 
             appo_let.mittente.cognome, 
             appo_let.mittente.indirizzo, 
             appo_let.destinatario.nome, 
             appo_let.destinatario.cognome, 
             appo_let.destinatario.indirizzo, 
            &appo_let.tipo_lettera, 
             appo_let.data_spedizione            
            );
            
            if (appo_let.tipo_lettera==tipo)
            {
              printf("\nLettera di tipo %c trovata.",tipo);
              lettere_trovate++;
              UfficioPostale[numero_lettere]=appo_let;
              numero_lettere++;
            }        
         }
         
         if (lettere_trovate==0) printf("\nNessuna lettera trovata.",tipo);
        
        fclose(f); 
    }
    else printf("\nErrore nel file"); 
    
    return numero_lettere;
}

