/*
Ingegneria delle TeleComunicazioni
Esame del 20 Settembre 2004
*/

/*
Nome:
Cognome:
Matricola:
Posizione:
Progetto: 
   [ ] presentato
   [ ] da presentare
   [ ] non interessato
*/


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#define  MAX_ITEMS 100
#define  L_TIPOLOGIA    15
#define  L_ORARIO    6

struct s_corso
{
    int codice;
    char tipologia[L_TIPOLOGIA];
    int max_partecipanti;
    int num_partecipanti;
    char orario[L_ORARIO];
};

typedef struct s_corso Corso;

int CaricaDati (struct s_corso []);
void CorsiDisponibiliPerTipologia (struct s_corso [], char []);


int numero_corsi=0;

int main (void)
{
    Corso Piscina[MAX_ITEMS];
    char tipologia, scelta;
      
    numero_corsi=CaricaDati (Piscina);
    
    printf("\nCaricati %d elementi",numero_corsi);
    
    do
    {
        printf("\nCerca corsi per tipologia");
                
        do
        {
               printf("\nTipologia {Principiante, Intermedio, Avanzato}:");
               tipologia=getch();
        }
        while (!((tipologia=='P') || (tipologia=='I') || (tipologia=='A'))); 
        
        switch (tipologia)
        {
            case 'P': { CorsiDisponibiliPerTipologia (Piscina, "principianti"); break; }
            case 'I': { CorsiDisponibiliPerTipologia (Piscina, "intermedio"); break; }
            case 'A': { CorsiDisponibiliPerTipologia (Piscina, "avanzato"); break; }
        }    
        

                
        printf("\n\nAncora? (S/N)");
        scelta=getch();
        
    }
    while (!((scelta=='N') || (scelta=='n')));
   
    printf("\nPremi un tasto per terminare");
    getch();

    return 0;
}

void CorsiDisponibiliPerTipologia (struct s_corso Piscina[], char tipo[])
{
    int i;
    
    int princ_tot=0, princ_avail=0, inter_tot=0, inter_avail=0, avanza_tot=0, avanza_avail=0;
    
    printf("\n\n\nRicerca dei corsi di tipo %s\n======================================",tipo);

    for (i=0; i<numero_corsi; i++)
    {
        if ((strcmp(Piscina[i].tipologia,tipo)==0) && ((Piscina[i].max_partecipanti-Piscina[i].num_partecipanti)>0))
         {
             printf("\n%d\t%s\t%d posti",Piscina[i].codice,Piscina[i].orario,Piscina[i].max_partecipanti-Piscina[i].num_partecipanti);
         }
        
        /*Calcoli per il riassunto*/
         if (strcmp(Piscina[i].tipologia,"intermedio")==0)
         {
             inter_tot++;
             if ((Piscina[i].max_partecipanti-Piscina[i].num_partecipanti)>0) inter_avail++;
         }
          if (strcmp(Piscina[i].tipologia,"principianti")==0)
         {
            princ_tot++;  
            if ((Piscina[i].max_partecipanti-Piscina[i].num_partecipanti)>0) princ_avail++;
         } 
          if (strcmp(Piscina[i].tipologia,"avanzato")==0)
         {
            avanza_tot++;
            if ((Piscina[i].max_partecipanti-Piscina[i].num_partecipanti)>0) avanza_avail++;
         }     
    }

    printf("\n\nRiassunto:\nPRINCIPIANTI:\tcorsi %d di cui %d con ancora posti disponibili",princ_tot,princ_avail);
    printf("\nINTERMEDIO:\tcorsi %d di cui %d con ancora posti disponibili",inter_tot,inter_avail);
    printf("\nAVANZATO:\tcorsi %d di cui %d con ancora posti disponibili",avanza_tot,avanza_avail);
    
    return;
}


int CaricaDati (struct s_corso Piscina[])
{
    FILE *f;
    struct s_corso appo_corso;
    int corsi_trovati=0;
               
    if ((f=fopen("Corsi.txt", "r")) != NULL)
    {
        printf("\nFile aperto. Inizio la lettura\n");  
        
        while (!feof(f))
        {
            fscanf(f, "%d %s %d %d %s", 
             &appo_corso.codice, 
             appo_corso.tipologia, 
             &appo_corso.max_partecipanti, 
             &appo_corso.num_partecipanti, 
             appo_corso.orario
            );

            Piscina[corsi_trovati]=appo_corso;
            
            corsi_trovati++;
            
         }
         
         if (corsi_trovati==0) printf("\nNessun corso trovatao");
        
        fclose(f); 
    }
    else printf("\nErrore nel file"); 
    
    return corsi_trovati;
}

